unit uPresupuestosReportController;

interface

uses
  Classes, SysUtils, uDADataTable, uControllerBase, uIDataModulePresupuestosReport,
  uClientesController, uPresupuestosController, uDetallesPresupuestoController,
  uBizPresupuestos;

type
  IPresupuestosReportController = interface
  ['{23C6A8F9-E9D3-4C57-8AD8-F798DC60D588}']
    procedure Preview(const AID : integer);
    procedure Print(const AID : integer);
  end;

  TPresupuestosReportController = class(TInterfacedObject, IPresupuestosReportController)
  private
    FDataModule : IDataModulePresupuestosReport;
    function CreateEditor(const AName: String; const IID: TGUID; out Intf): Boolean;
  public
    constructor Create;
    destructor Destroy; override;

    procedure Preview(const AID : integer);
    procedure Print(const AID : integer);
  end;


implementation

uses
  uROTypes, uEditorRegistryUtils, uIEditorPresupuestosPreview,
  uEditorPreview, uDataModulePresupuestos, uEditorBase, cxControls;

{ TPresupuestosReportController }

constructor TPresupuestosReportController.Create;
begin
  FDataModule := TDataModulePresupuestos.Create(Nil);
end;

function TPresupuestosReportController.CreateEditor(const AName: String;
  const IID: TGUID; out Intf): Boolean;
begin
  Result := Supports(EditorRegistry.CreateEditor(AName), IID, Intf);
end;


destructor TPresupuestosReportController.Destroy;
begin
  FDataModule := NIL;
  inherited;
end;

procedure TPresupuestosReportController.Preview(const AID : integer);
var
  AStream: Binary;
  AEditor : IEditorPresupuestosPreview;
begin
  AEditor := NIL;

  ShowHourglassCursor;
  AStream := FDataModule.GetReport(AID);
  try
    CreateEditor('EditorPresupuestosPreview', IEditorPresupuestosPreview, AEditor);
    AEditor.LoadFromStream(AStream);
  finally
    AStream.Free;
    HideHourglassCursor;
  end;

  if Assigned(AEditor) then
    AEditor.Preview;
end;

procedure TPresupuestosReportController.Print(const AID : integer);
var
  AStream: Binary;
  AEditor : IEditorPresupuestosPreview;
begin
  AEditor := NIL;

  ShowHourglassCursor;
  AStream := FDataModule.GetReport(AID);
  try
    CreateEditor('EditorPresupuestosPreview', IEditorPresupuestosPreview, AEditor);
    AEditor.LoadFromStream(AStream);
  finally
    AStream.Free;
    HideHourglassCursor;
  end;

  if Assigned(AEditor) then
    AEditor.Print
end;

end.
